# Arch installer

## Running the installer

### Via custom livemedium

1) Build custom [archiso](https://gitlab.archlinux.org/archlinux/archiso) live medium using docker in privileged mode:

```shell
# dependencies: docker, docker-compose

cd build-archiso
sudo docker-compose run archiso
ls out/out_dir/*.iso
```

2) Boot into the live medium
3) (Optional) Run `screen` (to be able to scroll back in case of any errors)
4) Adjust `/etc/de-p1st-installer/installer.cfg` (or delete it for interactive mode)
5) Run the installer

```shell
de-p1st-installer
```

### Via official livemedium

1) Boot into the live medium from [archlinux.org](https://archlinux.org)
2) Add to `/etc/pacman.conf`:

```shell
[de-p1st]
SigLevel = Optional TrustAll
Server = https://arch.p1st.de
```

3) (Optional) Install screen with a `screenrc` configuration file for long scrollback history
   
```shell
pacman -Sy
pacman -S de-p1st-screen
```

4) Install `de-p1st-installer` to get the install script
   
```shell
pacman -Sy
pacman -S de-p1st-installer
```

5) Continue with step (3) of "Via custom livemedium"
